Bug 1505444 - (CVE-2017-13089) CVE-2017-13089 wget: Stack-based buffer overflow in HTTP protocol handling
CVE-2017-13089 wget: Stack-based buffer overflow in HTTP protocol handling
Status: CLOSED ERRATA
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
high Severity high
: ---
: ---
Assigned To: Red Hat Product Security
impact=important,public=20171026:1500...
: Security
Depends On: 1505491 1505488 1505489 1505490 1506720
Blocks: 1505449
  Show dependency treegraph
 
Reported: 2017-10-23 11:08 EDT by Adam Mariš
Modified: 2018-02-12 03:54 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
A stack-based buffer overflow when processing chunked, encoded HTTP responses was found in wget. By tricking an unsuspecting user into connecting to a malicious HTTP server, an attacker could exploit this flaw to potentially execute arbitrary code.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-10-27 05:58:54 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Upstream patch (1.07 KB, patch)
2017-10-23 11:10 EDT, Adam Mariš
no flags Details | Diff

  None (edit)
Description Adam Mariš 2017-10-23 11:08:44 EDT
A stack-based buffer overflow vulnerability was found in HTTP protocol handling, potentially allowing a code execution.

The http.c:skip_short_body() function is called in some circumstances, such as when processing redirects. When the response is sent chunked, the chunk parser uses strtol() to read each chunk's length, but doesn't check that the chunk length is a non-negative number. The code then tries to skip the chunk in pieces of 512 bytes by using the MIN() macro, but ends up passing the negative chunk length to connect.c:fd_read(). As fd_read() takes an int argument, the high 32 bits of the chunk length are discarded, leaving fd_read() with a completely attacker controlled length argument.
Comment 2 Adam Mariš 2017-10-23 11:10 EDT
Created attachment 1342258 [details]
Upstream patch
Comment 6 Adam Mariš 2017-10-24 04:44:34 EDT
Acknowledgments:

Name: the GNU Wget project
Comment 8 Stefan Cornelius 2017-10-24 07:14:26 EDT
Looks like this was introduced via
http://git.savannah.gnu.org/cgit/wget.git/commit/?id=1cee0861627ce56a880fa300960136aac0cf0fe1

RHEL6 does not have this code.
Comment 10 Stefan Cornelius 2017-10-26 05:32:42 EDT
Statement:

This issue affects the versions of wget as shipped with Red Hat Enterprise Linux 7. This issue did not affect the versions of wget as shipped with Red Hat Enterprise Linux 5 and 6.
Comment 12 Stefan Cornelius 2017-10-26 12:10:51 EDT
Created wget tracking bugs for this issue:

Affects: fedora-all [bug 1506720]
Comment 14 errata-xmlrpc 2017-10-26 12:46:04 EDT
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2017:3075 https://access.redhat.com/errata/RHSA-2017:3075

Note You need to log in before you can comment on or make changes to this bug.